%% This version of POPT has been designed for informal identifiability 
%% analysis of fixed and mixed effects models
%%
%% REFERENCES: 
% Shivva, V., Korell, J., Tucker, I.G., Duffull, S.B.  
% An approach for identifiability of population pharmacokinetic
% -pharmacodynamic models. CPT: Pharmacometrics and Syst Pharmacol. 
% (2013) 2(6):e49. doi:  10.1038/psp.2013.25
%
% Shivva, V., Korell, J.K., Tucker, I.G., Duffull, S.B. 
% Parameterisation affects identifiability of population models. 
% J Pharmacokinet Pharmacodyn (2014) 41(1):81-86.
%%
%% This program is free software; you can redistribute it and/or
%% modify it under the terms of the GNU General Public License as 
%% published by the Free Software Foundation; either version 2 of 
%% the License, or (at your option) any later version.
%% 
%% This program is distributed in the hope that it will be useful, 
%% but WITHOUT ANY WARRANTY; without even the implied warranty of
%% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%% General Public License for more details.
%%
%% POPT (C) copyright Stephen Duffull ver 5.0; March 2015
%% PFIM_M (C) copyright Stephen Duffull ver 1.2(i) May; 28th 2003
%% TO MAINTAIN DESIRED FUNCTIONALITY, DO NOT EDIT THIS FILE
%% 

clear all

clc

format short g
 warning off %MATLAB:divideByZero
 warning('off','MATLAB:dispatcher:InexactMatch')

tic
variance_ruv;
sdaddv=sqrt(ruv_variance);
cstep=1e-10; % complex step derivative for variance elements
popt_ini



if sia==2
    count_mod=1; % dose
    idose=1;
    IDMAX=mr+1;
    popt_observe;

    return
end


lbound=BETAI./BETAI_range;
ubound=BETAI.*BETAI_range;

popt_ini2
NT=zeros(size(NUM_SUB))+NT;
DI=zeros(size(NT))+DI;

smmr=0;
counter_idi=0;
counter_notidi=0;
if mr==1
    mr=0;
    smmr=1;
end
if sia==1
    number_it=length(sdaddv)
end

for jjj=1:number_it
% jjj
    if rem(jjj,50)==0
        jjj
        counter_idi
    end

    desgn=1;
    robust_meth=0;

    popt_ini3


    lockout_flag=0;
    TT_mem_flag=0;
%    if method==10
%        COV_SPACE=load('covariates.txt');
%        num_cov_init=size(COV_SPACE);
%        num_ind_cov=num_cov_init(1,1);
%        num_cov=num_cov_init(1,2);
%    end

%     if isempty(DPMID==1)
%         DPMID=ones(size(DPM));
%     end
    IDMAX=max(DPMID);
    if length(sd_propi) > IDMAX | length(sd_addi) > IDMAX
        disp(['DPM is wrong size for RUV'])
    end
%     if lockout==0;
%         lockout_flag=0;
%     end

%     if constr==0
%         fail=0;
%     end
    if method==0
        re_scale=0;
    end
    nd=(size(D));
    nd=nd(1,2);

    ntd=max(size(NT));
    ndi=max(size(DI));
    ndpm=max(size(DPM));

    % *** WARNINGS ***

    % initialising default values
    md=0;
%     if max(DN) > 1
%         md=0;
%     else
%         md=0;
%     end
    C_D=size(BETAI);
    num_models=C_D(1);

    if num_models > 1
        comp_des=1;
    else
        count_mod=1;
        BETA1=BETAI;
        O=OI;
        BSVMOD=BSVMODI;
        FXF=FXFI;
        FX=FXI;
    % 	FXR=FXRI;
        sd_prop=sd_propi;
        sd_add=sd_addi;

        % initialising dimensions
        nparam=length(BETA1);  
        fxnf=length(FXF);
        fxn=length(FX);
        fxnr=sum(FXRI>0);
        [r c]=size(sd_prop);
        nsig=c;
        [r c]=size(sd_add);
        nsig=nsig+c;
        comp_des=0;
        counter=0;
        if sum(FXRI)==0
            FXR=[];
        else
            for ijkl=1:length(FXRI)
                if FXRI(ijkl)>0
                    counter=counter+1;
                    FXR(counter)=ijkl;
                end
            end
        end

        % ******************************************************
        % ******* initialising various variables ***************
        % ******************************************************

        MB=zeros(nparam-fxnf,nparam-fxnf);
        ML=zeros(nparam+nsig-fxn,nparam+nsig-fxn);
        MF=zeros(nparam*2+nsig-fxn-fxnf-fxnr,nparam*2+nsig-fxn-fxnf-fxnr);
        MFD=MF;
        OMEGA=eye(nparam); % was OMEGA=eye(nparam,nparam)
        Z=zeros(nparam,1);
        ODP=zeros(nd,max(NT));

        % initialise parameter values

        for z=1:nparam
            OMEGA(z,z)=OMEGA(z,z)*O(z);
        end
        SIG=[];
        SIG_ID=[];
        SIG_TYPE=[];

        for ijkl=1:IDMAX
            SIG=[SIG sd_prop(ijkl) sd_add(ijkl)];
            SIG_ID=[SIG_ID ijkl ijkl];
            SIG_TYPE=[SIG_TYPE 1 2];
        end
        THETA=BETA1;
    end
    VAR=SIG;



    if sum(UBA) == 0
        UBR=[];
        for ijklmno=1:nd
            UBQ=ones(1,NT(ijklmno))*DI(ijklmno);
            UBR=[UBR UBQ];%UBR=cat(2, UBR, UBQ);
        end
        UBA=UBR;
        
    end
    if sum(LBA) == 0
        LBA = zeros(1, sum(NT));
    end
    if sum(DN) ==0
        DN = ones(1, sum(NT));
    end
    NS = NUM_SUB;

    if sum(FX_DPM) ==0
        FX_DPM = zeros(1, sum(NT));
    end

    if isempty(DC)==1
        dc_tot=ones(size(DN));
        DC=ones(size(unique(DN)));
    else
        b=unique(DN);
        for ij=1:length(b)
            c=find(DN==b(ij));
            dc_tot(c)=repmat(DC(ij),length(c),1);
        end
    end


    % numerical difference used in approximation of partial derivatives 
    % h is the proportional term (usual h=1e-5), h2 is additive (usual h2=1e-7)
    h=1e-5;
    h2=1e-6; %normally 1e-6

    if desgn==1
        % NB UBA and LBA will need to be converted to a (1xntot) vector, where ntot=sum(NT)
        ntot=sum(NT);
    else
        ntot=nd;
    end

    %If UBA & LBA are matrices then the following transformations are required.
    UB(1:ntot)=UBA';
    LB(1:ntot)=LBA';
    DP=[];
    for ijklmno=1:nd
        DP=[DP DPM];
    end
    DPM=DP;
%     DP(1:ntot)=DPM';

    % zero variable names
    ifig=0;
    ntot=0;

    if desgn==1
        for idose=1:nd
            ntot=ntot+NT(idose);
        end
    else
        ntot=nd;
    end

    nt1=NT(1);
    n_ntot=ntot;
    DP=DPM;
    part=0;

    pop_run

    logdeterminant(jjj)=log(det(MFD));
    determinant(jjj)=det(MFD);
    if sia==1
        logvar(jjj)=log(sdaddv(jjj));
    end
    if sia~=1
        get_se

        objv=sum(RSE(:,jjj));
        if jjj==1
            objv_worst=0;
        end
        if jjj>1
            if objv > objv_worst
                BETA_worst=BETAI;
                RSE_worst=RSE(:,jjj)';
                objv_worst=objv;
                Mean_BETAI=BETAI;
    %             stop
                BETAI_traj(:,jjj)=BETAI;
            end
        end
        BETAI_traj(:,jjj)=BETAI;
        if rem(jjj, 200) ==0
            vscale=vscale*0.1
        end
        if sum(RSE(:,jjj)>max_rse) > 0
            counter_idi=counter_idi+1;
            BETA_keep(counter_idi, :)=BETAI;
            RSE_keep(counter_idi, :)=RSE(:,jjj)';
    %         stop

        else
            counter_notidi=counter_notidi+1;
            BETA_notIDI(counter_notidi, :)=BETAI;
        end
    end
end


if sia==1
    a1=find(imag(logdeterminant));
    % a2=find(logdeterminant==inf|logdeterminant==-inf);
    a3=find(real(logdeterminant==0));
    a4=sum(logdeterminant<=0);
    
    % a1 > 0 | a2 > 0 | a3 > 0 |

    if  isempty(a1)==0 | isempty(a3)==0 | a4 > 0 | max(determinant) < 1
        iden=('The model is not structurally identifiable');
    else
        iden=('The model is structurally identifiable');
    end
    LogVar_vs_LogDet=[logvar' logdeterminant' determinant'];

    diary('Identifiability.res')
    display('       Log var     Log Det     Det')
    display([LogVar_vs_LogDet]);
%     LogVar_vs_LogDet
    iden
    diary off

    logdeterminantr=logdeterminant;
    logdeterminantr(a1)=0;
    % logdeterminantr(a2)=0;


    figure(1)
    plot(logvar, logdeterminantr)
    ylabel('log determinant')
    xlabel('log residual variance')

end
if sia==0
    counter_idi
    if counter_idi > 0
        iden=('The model is not internally identifiable');
        BETA_keep
        RSE_keep
    else
        iden=('The model is internally identifiable');
    end
    diary('Identifiability.res')
    iden
    diary off
    if counter_idi > 0
        figure(1)
        plot(1:number_it,BETAI_traj)
        figure(2)
        semilogy(1:number_it,BETAI_traj)
        
    end 
end
toc
