%% This program is free software; you can redistribute it and/or
%% modify it under the terms of the GNU General Public License as 
%% published by the Free Software Foundation; either version 2 of 
%% the License, or (at your option) any later version.
%% 
%% This program is distributed in the hope that it will be useful, 
%% but WITHOUT ANY WARRANTY; without even the implied warranty of
%% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%% General Public License for more details.
%%
%% POPT (C) copyright Stephen Duffull ver 4.0; Aug, 17th 2011
%% PFIM_M (C) copyright Stephen Duffull ver 1.2(i) May; 28th 2003
%%
%% TO MAINTAIN DESIRED FUNCTIONALITY, DO NOT EDIT THIS FILE
%%
%% POPT_INI2 (C) copyright Stephen Duffull ver 3.0 March, 2015
%%

weighting=[];

Mean_BETAI=BETAI;
vscale=1;
di=4*expected_halflife;
DI=max(di,24);

if mr==1
    nmodels=2;
else
    nmodels=1;
end
if length(weighting)>2
    display('more than 2 models is not supported')
    return
end


% ** Elementary design variables **

% initial estimates of time points per elementary design

incr=DI/((number_of_samples*DI/24)/nmodels-1);
DPM=exp([-4:incr/5:log(DI)]);
% DPM=[0:incr:DI];

% NT1=max(length(DPM), 3*length(BETAI));
NT1=length(DPM);

NT=[NT1]*nmodels; % number of observations


DPMID=ones(size(DPM));
if nmodels==2
    DPM_temp=DPM;
%     DPM(length(DPM)+1:2*length(DPM))=[0:incr:DI];
%     DPMID(NT/nmodels+1:2*(NT/nmodels))=ones(1,NT/nmodels)+1;
    DPM(length(DPM)+1:2*length(DPM))=DPM_temp;
    DPMID(length(DPM_temp)+1:2*length(DPM_temp))=ones(size(DPM_temp))+1;
end

% do you want information matrix to be zeros when dose = 0 - if so then set
% dose_zero_fix to 1
dose_zero_fix=0;


% for an exchange algorithm enter a finite number of possible times DPE
% DO NOT enter 0 (zero) as this is a reserved time
DPE=[];

% Enter the index of design points: position 1 = number of sampling times,
% position 2 = the number of possible sampling times under consideration
DPE_index=[];

% fix sampling times: fixed = 1, variable = 0
% FX_DPM must have the same number of elements as DPM
% default: FX_DPM=[] -> nothing fixed
FX_DPM=[];

% dose number that sampling time is selected from
% DN should have the same number of elements as DPM
% default: DN=[] will result in the dose number to be 1 for all doses
DN=[];

%DN=[];

% if you want to zero compartments between dose levels (i.e. to give no
% carryover effect then set zero_cpts=1.
zero_cpts=0;

% if choosing method=7 then insert the maximum dose number for each 
% dose group
MX_DN=[];

% upper bounds for design points per elementary design
% default: UBA=[] will result in the upper bound being set at the dose interval (DI)


UBA=[];
% lower bounds for design points per elementary design
% default: LBA=[] will result in the lower bound being set to zero

LBA=[];

% ***************** OPTIMISATION FEATURES **************

% Toggle GUI screen output off (=0) on (=1)
output_on = 0;

% Sound_on=1 to finish run with audible comment
sound_on=0;

% print intermediate result step size - must be an integer
% NB the smaller values of [prnt] will lengthen computation times
prnt=50;

% If there are large scale differences between the design points then the
% design points can be rescaled
% [re_scale=0]: no scaling
% [re_scale=1]: design points scaled to 1
re_scale=0;

% Constrained design.  If method>0 and method < 6 then this constrains the
% design such that sampling time n+1 > sampling time n
% [constr=0]: no constraints
% [constr=1]: constrained
constr=0;

% For constraining sampling times to be the same for each patient in each group
% [dpm_constrain=0]: no constraint
% [dpm_constrain=1]: constrains sampling times to be the same for each
% patient (but not the dose number that samples are taken from)
% [dpm_constrain=2]: constrains sampling times to be the same for each occasion
% [dpm_constrain=3]: constrains all sampling times within a period to be
% the same [only with method=8]
% NB: using this function all groups MUST have the same number of sampling times
% [dpm_constrain=4]: constraints all sampling times to arise from 2 groups -
% use with dpm_4_group variable to indicate the split
% [dpm_constrain=5]: constrains all sampling times after a defined group number
% to be the same for all remaining groups as for the previous group.  So
% for this setup all subsequent groups must be the same size as the
% immediately prior group.  e.g. if dpm_4_group=2 and there are 3 groups
% then group 3 samples times will equal group 2 sampling times but group 1
% does not have to equal group 2.
% [dpm_constrain=6] - constrains sampling times to be the same between
% responses - there must be an equal number of observations for each
% response
dpm_constrain=0;

% If dpm_constrain=2 then how many samples are there per occasion?
first_occ=0;

% If dpm_constrain=3 then for what time period should all samples be the same?
% WARNING: you must ensure that ALL patients have the same number of
% samples that will occur within the dpm_3_time period.  Do this by fixing
% boundaries with UBA.  
% WARNING: all samples within this period should be exchangeable (as they
% are sorted) therefore DN must be the same - this cannot be tested for!
dpm_3_time = 0;

% use this variable with dpm_constrain=4 or dpm_constrain=5.  Use dpm_4_group to indicate how
% many groups should be grouped together and have the same sampling times.
dpm_4_group=0;

% Resolution.  Enter the smallest signigicant difference allowable
% between consecutive sampling times.  If sampling times are allowed to be
% replicated then set lockout=0
lockout=0;

% To optimize estimation of each patients individual parameter vector as
% well as the population parameter vector then set ind_infomatrix = 1
% otherwise ind_infomatrix = 0 is the usual optimization problem
ind_infomatrix = 0;

% computer EBE SE Yes: MAP_ind=1 , ind_informatrix must be 1 here.
MAP_ind=0;

% Do you want to show the combined individual + population criterion [0=no;
% 1=yes]
show_ind_crit = 0;

% LLOQ, value (lloq=), stop designs going lloq (set use_lloq=1, ignore use_lloq=0)
lloq=0;
use_lloq=0;

% ***************** OPTIMISATION METHOD FEATURES **************

% method for optimisation: 
% [method=0]: none
% [method=1]: simplex
% [method=2]: non-adaptive random search
% [method=3]: simulated annealing (SA) superseeded by [method=8]
% [method=4]: grid (partitions=100 2D only)
% [method=5]: compute expectation over sampling times
% [method=6]: SA with approximate design over treatment allocation
% [method=7]: SA with DN optimised too [method=7]
% [method=8]: SA with fixed times - this method superseeds [method=3]
% [method=9]: exchange algorithm (k=1)
% [method=10]: compute expectation of info matrix over covariate space
% [method=11]: exchange algorithm (k=2)
% [method=12]: exchange on sensitivities (k=1)
method=0;

% If using method=0 then you can choose to select the FOCE linearisation,
% FOCE=0 defaults to the standard FO approximation and a value of 1 applies
% the FOCE approximation
FOCE=0;

% If using FOCE=1 then set the number of Monte Carlo steps in the
% integrator
FOCE_num_int=250;

%%%%%%%%%%%%%%%%%%%%
% SIMULATED ANNEALING [method=3, 5-8] - then the algorihm has
% [method_sa=0]: normal
% [method_sa=1]: fast
% [method_sa=2]: fastest
% NB: The slow method option may be more accurate.
% method_sa=2, provides graded temp decline: % >change_one = normal, change_two:change_one = /10th, <change_two = 1/100th
method_sa=2;
change_one=1;
change_two=1e-5;

% convergence (minv) and initial temp (tempe)
minv=1e-4;
tempe= 1000;

%%%%%%%%%%%%%%%%%%%%

% NONADAPTIVE RANDOM SEARCH [method = 2] then how many samples (usual 10000)
rwt=10000;

%%%%%%%%%%%%%%%%%%%%

% EXPECTATION OVER PRIOR [methods = 5, 10] then number of samples to compute the expectation 
n_exp=1000;
% if using method=10 then this method calculates the expectation of the
% information matrix for a given design from your covariates.  It does this
% by non-parametric sampling (with replacement) from a file called
% covariates.txt which you have created previously.  Resampling occurs by
% whole rows in order to preserve the natural correlation with an individual.
% It calls covariates in the first column COV(1), second column COV(2) etc.  
% These can then be written into the p_model file accordingly.

%%%%%%%%%%%%%%%%%%%%

% EXCHANGE ALGORITHM [method=9] then how many times should the sample space be randomly
% rearranged - recommend at least 1
num_rand_arrangments = 1;
% number of intervals to divide the design space into for combinatory
% searching
dpe_num=25;

% ***************** PRIOR INFORMATION **************

% prior1 = ? study ? weighting 

% prior2 = older paeds study to get half weighting
%MFD_prior(:,:,1)=;
      
        
% do you want ot use prior
use_prior=0;

% is this matrix the same size as the one you're trying to estimate
matrix_resize=0 ; % set this to zero if you don't want to resize the matrix and to 1 if you do



% approximate design (method=6) total number of subjects [ns] and maximum
% number of blood samples [maxs]
ns=5000;
maxs=15000;

% too give a different dose to each patient on each visit then enter the
% fractional dose in the field DC [dose change].  This vector must the same length as the 
% number of unique elements in DN.  For example if DN=[1 1 1 2 2 2] then DC
% should have 2 elements e.g. DC=[1 4] which means that the dose level on
% the second occasion is 4 times that of the first occasion
DC=[];
